******------------------------------------------------------------------
*     Random number generator from the authors of Numerical Recipes.
*     Obtained from Prof. C. E. I. Carneiro.
*     Start with a large negative seed.
******------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION RAN (iseed)
******------------------------------------------------------------------
      parameter
     *     (ia=16807
     *     ,im=2147483647
     *     ,am=1./im
     *     ,iq=127773
     *     ,ir=2836
     *     ,ntab=32
     *     ,ndiv=1+(im-1)/ntab
     *     ,eps=1.2e-7
     *     ,rnmx=1.-eps)
******------------------------------------------------------------------
      integer j,k,iv(ntab),iy
      save iv,iy
******------------------------------------------------------------------
      data iv/ntab*0/
     *     ,iy/0/
******------------------------------------------------------------------
      if (iseed.le.0.or.iy.eq.0) then
         iseed=max(-iseed,1)
         do j=ntab+8,1,-1
            k=iseed/iq
            iseed=ia*(iseed-k*iq)-ir*k
            if (iseed.lt.0) iseed=iseed+im
            if (j.le.ntab) iv(j)=iseed
         end do
         iy=iv(1)
      end if
******------------------------------------------------------------------
      k=iseed/iq
      iseed=ia*(iseed-k*iq)-ir*k
      if (iseed.lt.0) iseed=iseed+im
      j=1+iy/ndiv
      iy=iv(j)
      iv(j)=iseed
      ran1=min(am*iy,rnmx)
      ran=dble(ran1)
******------------------------------------------------------------------
      return
      END    
******------------------------------------------------------------------
